<?php

namespace B2buy\Supplier\Repositories\Presenter;

use League\Fractal\TransformerAbstract;
use Hashids;

class SupplierTransformer extends TransformerAbstract
{
    public function transform(\B2buy\Supplier\Models\Supplier $supplier)
    {
        return [
            'id'                => $supplier->getRouteKey(),
            'key'               => [
                'public'    => $supplier->getPublicKey(),
                'route'     => $supplier->getRouteKey(),
            ], 
            'reporting_to'      => $supplier->reporting_to,
            'name'              => $supplier->name,
            'email'             => $supplier->email,
            'password'          => $supplier->password,
            'company_name'      => $supplier->company_name,
            'abn'               => $supplier->abn,
            'title'             => $supplier->title,
            'api_token'         => $supplier->api_token,
            'remember_token'    => $supplier->remember_token,
            'sex'               => $supplier->sex,
            'dob'               => $supplier->dob,
            'designation'       => $supplier->designation,
            'mobile'            => $supplier->mobile,
            'phone'             => $supplier->phone,
            'address'           => $supplier->address,
            'financial_authorization' => $supplier->financial_authorization,
            'work_email'        => $supplier->work_email,
            'alternative_phone' => $supplier->alternative_phone,
            'street'            => $supplier->street,
            'city'              => $supplier->city,
            'district'          => $supplier->district,
            'state'             => $supplier->state,
            'country'           => $supplier->country,
            'photo'             => $supplier->photo,
            'web'               => $supplier->web,
            'permissions'       => $supplier->permissions,
            'email_verified_at' => $supplier->email_verified_at,
            'user_id'           => $supplier->user_id,
            'user_type'         => $supplier->user_type,
            'user_mode'         => $supplier->user_mode,
            'upload_folder'     => $supplier->upload_folder,
            'deleted_at'        => $supplier->deleted_at,
            'team_id'           => $supplier->team_id,
            'trading_name'      => $supplier->trading_name,
            'duns_number'       => $supplier->duns_number,
            'registered_office' => $supplier->registered_office,
            'fb_url'            => $supplier->fb_url,
            'linkedin_url'      => $supplier->linkedin_url,
            'directors'         => $supplier->directors,
            'documents'         => $supplier->documents,
            'url'               => [
                'public'    => trans_url('supplier/'.$supplier->getPublicKey()),
                'user'      => guard_url('supplier/supplier/'.$supplier->getRouteKey()),
            ], 
            'status'            => trans('app.'.$supplier->status),
            'created_at'        => format_date($supplier->created_at),
            'updated_at'        => format_date($supplier->updated_at),
        ];
    }
}