<?php

namespace B2buy\Supplier;

use User;

class Supplier
{
    /**
     * $supplier object.
     */
    protected $supplier;

    /**
     * Constructor.
     */
    public function __construct(\B2buy\Supplier\Interfaces\SupplierRepositoryInterface $supplier)
    {
        $this->supplier = $supplier;
    }

    /**
     * Returns count of supplier.
     *
     * @param array $filter
     *
     * @return int
     */
    public function count()
    {
        return  0;
    }

    /**
     * Make gadget View
     *
     * @param string $view
     *
     * @param int $count
     *
     * @return View
     */
    public function gadget($view = 'admin.supplier.gadget', $count = 10)
    {

        if (User::hasRole('user')) {
            $this->supplier->pushCriteria(new \Litepie\B2buy\Repositories\Criteria\SupplierUserCriteria());
        }

        $supplier = $this->supplier->scopeQuery(function ($query) use ($count) {
            return $query->orderBy('id', 'DESC')->take($count);
        })->all();

        return view('supplier::' . $view, compact('supplier'))->render();
    }
}
